#if !defined(AFX_TRAINPAGEDLG_H__6E69DDD0_56FF_11D7_B5F1_F0D8D6F05C10__INCLUDED_)
#define AFX_TRAINPAGEDLG_H__6E69DDD0_56FF_11D7_B5F1_F0D8D6F05C10__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TrainPageDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTrainPageDlg dialog
#include "bpnet\BPNet.h"


class CTrainPageDlg : public CPropertyPage
{
	DECLARE_DYNCREATE(CTrainPageDlg)

// Construction
public:
	CTrainPageDlg();
	~CTrainPageDlg();

	// function for training thread
	static unsigned int __stdcall threadProc(void* context);

// Dialog Data
	//{{AFX_DATA(CTrainPageDlg)
	enum { IDD = IDD_TRAIN_PAGE_DLG };
	CSliderCtrl	m_sliderNPCExp;
	CSliderCtrl	m_sliderNPCInt;
	CListCtrl	m_listTrainSet;
	double	m_learningRate;
	double	m_momentum;
	BOOL	m_boolAutoLr;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CTrainPageDlg)
	public:
	virtual BOOL OnKillActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CTrainPageDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnCheckAutoLR();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnButtonTrain();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


// Methods
private:	

	bool loadTrainingSet(const CString& fullPath);
	void fillTrainingSetList(int numPatterns);
	void enableControls(BOOL enable);

	void trainNetwork();

// Members
private:

	CString			_appPath;
	CString			_outFullPath;
	CImageList		_imageList;

	vector<Pattern>	_patterns;
	double			_tolerance;

	HANDLE			_hThread;
	bool			_stopThread;

	CString			_strGood;
	CString			_strIter;
	CString			_strTotError;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRAINPAGEDLG_H__6E69DDD0_56FF_11D7_B5F1_F0D8D6F05C10__INCLUDED_)
